//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Chart"
#pragma link "Series"
#pragma link "TeEngine"
#pragma link "TeeProcs"
#pragma link "TeeTools"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Series1->FillSampleValues(25);
  Series2->DataSource = Series1;
  Series2->ColorEachPoint = true;
  Chart1->Legend->Visible = false;
  Chart2->Legend->Visible = false;
  ChartTool1->Style = dlRectangle;
  ChartTool2->Style = dlRectangle;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::AssignLine(TDrawLines *LineFrom, TDrawLines *LineTo, int Index)
{
	LineTo->Line[Index]->Assign(LineFrom->Line[Index]);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::NewLine(TObject *Sender)
{
	if (Sender == ChartTool1)
	{
		ChartTool2->Lines->Add();
		AssignLine(ChartTool1->Lines, ChartTool2->Lines, ChartTool1->Lines->Count-1);
		Chart2->Refresh();
	}
	else //Sender = DrawLineTool2
	{
		ChartTool1->Lines->Add();
		AssignLine(ChartTool2->Lines, ChartTool1->Lines, ChartTool1->Lines->Count-1);
		Chart1->Refresh();
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DragLine(TObject *Sender)
{
   if (AllowDrag)
   {
	if (Sender == ChartTool1)
	{
	  AssignLine(ChartTool1->Lines, ChartTool2->Lines, ChartTool1->Selected->Index);
	  Chart2->Refresh();
	}
	else
	{
	  AssignLine(ChartTool2->Lines, ChartTool1->Lines, ChartTool2->Selected->Index);
	  Chart1->Refresh();
	}
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ChartMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y)
{
	if ((ChartTool1->Clicked(X,Y) != NULL) || (ChartTool2->Clicked(X,Y) != NULL))
	{
		AllowDrag = true;
	}
	else
	{
		AllowDrag = false;
	}
}
//---------------------------------------------------------------------------
