//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Chart.hpp"
#include "Series.hpp"
#include "TeEngine.hpp"
#include "TeeProcs.hpp"
#include <ExtCtrls.hpp>
#include "TeeTools.hpp"
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
	TChart *Chart1;
	TChart *Chart2;
	TPointSeries *Series1;
	TPointSeries *Series2;
	TDrawLineTool *ChartTool1;
	TDrawLineTool *ChartTool2;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall NewLine(TObject *Sender);
	void __fastcall DragLine(TObject *Sender);
	void __fastcall ChartMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y);
private:	// User declarations
	void __fastcall AssignLine(TDrawLines *LineFrom, TDrawLines *LineTo, int Index);
	Boolean AllowDrag;
public:		// User declarations
	__fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
